import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  ClassType,
  PropertyKeyType,
} from '@overflow/commons/core/type';

export interface WebApplicationAnnotationAttributes {
  jsonSources?: any[];
  injectables?: ClassType[];
  configurations?: ClassType[];
}

export class WebApplicationAnnotation implements Annotation {
  public readonly attributes: WebApplicationAnnotationAttributes;

  public constructor(attributes: WebApplicationAnnotationAttributes) {
    this.attributes = attributes;
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    // no op
  }

}

export const WebApplication = Decorator.create(WebApplicationAnnotation);
