import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface PreDestroyAnnotationAttributes {
  name?: string[];
}

export class PreDestroyAnnotation implements Annotation {
  public readonly attributes: PreDestroyAnnotationAttributes;

  public constructor(name: string | string[] | PreDestroyAnnotationAttributes) {

    if (undefined === name) {
      this.attributes = {
      };
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes = {
        name: [<string>name],
      };
    } else {
      this.attributes = <PreDestroyAnnotationAttributes>name;
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('PreDestroy');
  }

}

export const PreDestroy = Decorator.create(PreDestroyAnnotation);
