import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  TypeUtil,
} from '@overflow/commons/core/type';


export interface ReducerAnnotationAttributes {
  name?: string;
}

export class ReducerAnnotation implements Annotation {
  public readonly attributes: ReducerAnnotationAttributes;

  public constructor(name: string | ReducerAnnotationAttributes) {
    if (undefined === name) {
      this.attributes = {
        name: '',
      };
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes = {
        name: <string>name,
      };
    } else {
      this.attributes = <ReducerAnnotationAttributes>name;
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('Reducer');
  }
}

export const Reducer = Decorator.create(ReducerAnnotation);
