import {
  applyMiddleware,
  compose,
  createStore,
  GenericStoreEnhancer,
  Middleware,
  Store,
} from 'redux';

import {
  Inject,
} from '@overflow/commons/di/decorators';

import {
  Configuration,
  Instance,
} from '@overflow/commons/application/decorators';

import {WebAppDispatcherReducer} from '../redux';

@Configuration()
export class ReduxConfiguration {
  private static isProduction:boolean = process.env.NODE_ENV === 'production' ? true : false;
  private static useReduxDevTools:boolean = window.devToolsExtension && !ReduxConfiguration.isProduction ? true : false;

  @Inject()
  private dispatcherReducer: WebAppDispatcherReducer;

  @Instance()
  public store(): Store<any> {
    return createStore(
      this.dispatcherReducer.reducer,
      {},
      ReduxConfiguration.useReduxDevTools ? window.devToolsExtension() : undefined,
    );
  }
}
